#!/usr/bin/env python
# Generator of random IDEA messages with the same format as generated by
# Kippo/Cowrie connector.

from __future__ import print_function
import sys
from argparse import ArgumentParser
import re
import os.path
import random
from uuid import uuid4
from datetime import datetime, timedelta
from time import strftime, gmtime
import json

DEFAULT_NAME = 'org.example.test.kippo'
DEFAULT_AWIN = 5 # aggregation window (minutes)
DEFAULT_TARGET_NET = '192.168.25.0/24'
DEFAULT_SOURCE_NET = '10.0.0.0/16'
DEFAULT_RATE = 60.0

RE_CIDR = '^\d+\.\d+\.\d+\.\d+/\d+$'
RE_IP = '^\d+\.\d+\.\d+\.\d+$'
# TODO IPv6 support

def ipstr2int(ipstr):
    parts = list(map(int, ipstr.split('.')))
    assert len(parts) == 4, "IP address must have 4 octets"
    assert all(0 <= part <= 255 for part in parts), "some octet is outside the 0-255 range"
    return (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8) | parts[3]

def int2ipstr(ipint):
    return '.'.join(map(str, (ipint >> 24, (ipint >> 16) & 0xff, (ipint >> 8) & 0xff, ipint & 0xff)))


class random_ip_generator:
    # Generates random IP addresses from given CIDR network
    # (it's implemented manually to avoid dependency on any nonstandard packages)
    def __init__(self, cidr):
        try:
            net, prefix_len = cidr.split('/')
            ipint = ipstr2int(net)
            prefix_len = int(prefix_len)
            assert 0 <= prefix_len <= 32, "prefix length must be integer between 0 and 32"
            mask = ~((1 << (32-prefix_len)) - 1) & 0xffffffff
            assert ipint & ~mask == 0, "host part contains non-zero bits"
        except Exception as e:
            raise ValueError("Invalid CIDR: " + str(e))
        self.ipint = ipint
        self.prefix_len = prefix_len
        # If singe IP address, redefine next() method
        if prefix_len == 32:
            self.next = lambda: net

    def next(self):
        return int2ipstr(self.ipint + random.getrandbits(32 - self.prefix_len))



parser = ArgumentParser(description="Generator of random IDEA messages with the same format as generated by Kippo/Cowrie connector.")
parser.add_argument(metavar='TARGET_DIR', nargs='?', type=str, dest='dir',
                    help="Target directory to store the messages to (excluding 'incoming/' at the end). Print a message to stdout if not set.")
parser.add_argument('-c', metavar='CNT', dest='cnt', type=int, default=1,
                    help="Number of messages to generate (default: 1). Target directory must be set to allow more than one message.")
parser.add_argument('-n', '--name', metavar='NAME', type=str, default=DEFAULT_NAME,
                    help="Value of Node[0].Name field (default: '"+DEFAULT_NAME+"').")
parser.add_argument('-s', '--source', metavar='CIDR', type=str, default=DEFAULT_SOURCE_NET,
                    help="Network from which source addresses are generated (default: '"+DEFAULT_SOURCE_NET+"').")
parser.add_argument('-t', '--target', metavar='IP/CIDR', type=str, default=DEFAULT_TARGET_NET,
                    help="IP address or network set as Target. If network is used, Anonymised is set to True. If empty string, Target is not set (default: '"+DEFAULT_TARGET_NET+"').")
parser.add_argument('--test', action='store_true',
                    help='Add "Test" to Category.')
parser.add_argument('-T', '--time', metavar='YYYY-MM-DDTHH:MM:SS', type=str,
                    help="EventTime of the first event (default: current time).")
parser.add_argument('-r', '--rate', metavar='N', type=float, default=DEFAULT_RATE,
                    help="Average number of alerts per hour (default: '"+str(DEFAULT_RATE)+"').")


args = parser.parse_args()

# Check validity of arguments

if not args.dir and args.cnt > 1:
    print("ERROR: Target directory must be set to generate more than one message.", file=sys.stderr)
    sys.exit(1)

if args.dir and not os.path.isdir(args.dir):
    print("ERROR: Target path doesn't exist or isn't a directory.", file=sys.stderr)
    sys.exit(1)

if args.name.isdigit():
    print("ERROR: Name should't be a number (if you try to set the number of messages, use -c)", file=sys.stderr)
    sys.exit(1)

try:
    src_gen = random_ip_generator(args.source)
except ValueError as e:
    print("ERROR in Source spcification: " + str(e), file=sys.stderr)
    sys.exit(1)

if args.target != "":
    if re.match(RE_CIDR, args.target):
        anonymized = True
    elif re.match(RE_IP, args.target):
        anonymized = False
    else:
        print("ERROR: Target is not a valid IPv4 address nor CIDR network.", file=sys.stderr)
        sys.exit(1)

if args.time:
    try:
        starttime = datetime.strptime(args.time, "%Y-%m-%dT%H:%M:%S")
    except ValueError as e:
        print("ERROR: Invalid EventTime: ", str(e), file=sys.stderr)
        sys.exit(1)
else:
    starttime = datetime.now()

# Create temp/ and incoming/ subdirectories if not exist
if args.dir:
    temp_path = os.path.join(args.dir, "temp")
    if not os.path.exists(temp_path):
        os.mkdir(temp_path)
    inc_path = os.path.join(args.dir, "incoming")
    if not os.path.exists(inc_path):
        os.mkdir(inc_path)



# Generate IDEA messages
for i in range(args.cnt):
    # Generate changing parts of message
    
    # Round win_start_time to the size of AWIN (AWIN should not be more than hour)
    win_start_time = starttime.replace(minute = starttime.minute - (starttime.minute % DEFAULT_AWIN), second = 0)
    win_end_time = win_start_time + timedelta(minutes=DEFAULT_AWIN)
    detect_time = win_end_time + timedelta(seconds=random.randint(1,3))
    
    conn_count = int(random.expovariate(0.1) + 1.0)
    
    source = src_gen.next()
    target = args.target
    
    # Create message
    idea = {
        "Format": "IDEA0",
        "ID": str(uuid4()),
        "DetectTime": detect_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "WinStartTime": win_start_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "WinEndTime": win_end_time.strftime("%Y-%m-%dT%H:%M:%SZ"),
        "Category": ["Attempt.Login"] + (["Test"] if args.test else []),
        "Note": "SSH login attempt",
        "ConnCount": conn_count,
        "Source": [{}],
        "Target": [
            {
               "Proto": ["tcp", "ssh"],
               "Port" : [22]
            }
        ],
        "Node": [
            {
               "Name": args.name,
               "Type": ["Connection","Honeypot","Recon"],
               "SW": ["Kippo"],
               "AggrWin": strftime("%H:%M:%S", gmtime(DEFAULT_AWIN*60))
            }
        ]
    }
    
    # Fill IP addresses
    af = "IP4" if not ':' in source else "IP6"
    idea['Source'][0][af] = [source]
    
    if args.target != "":
        if anonymized:
            idea['Target'][0]['Anonymised'] = True
            idea['Target'][0][af] = [target]
        else:
            idea['Target'][0][af] = [target]

    
    # Store the message
    if args.dir:
        # Write message to temp/ directory
        filename = idea['ID'] + ".idea"
        with open(os.path.join(temp_path, filename), "w") as f:
            json.dump(idea, f)
        # Atomically move it to incoming/ directory
        os.rename(os.path.join(temp_path, filename), os.path.join(inc_path, filename))
    else:
        # Print to stdout if directory is not given
        print(json.dumps(idea, indent=4))
    
    # Move time for the next message
    # (model it as Poisson process, i.e. exponentially distributed random delays with lambda = rate)
    starttime += timedelta(seconds=int(random.expovariate(args.rate)*3600))
